import type { Writable, Readable } from 'svelte/store';
declare type AsyncValue<T> = Promise<T>;
declare type Stores = [Readable<any>, ...Array<Readable<any>>];
declare type StoresValues<T> = T extends Readable<infer U>
    ? U
    : {
          [K in keyof T]: T[K] extends Readable<infer U> ? U : never;
      };
export interface Asyncable<AsyncValue> extends Writable<AsyncValue> {
    get: () => AsyncValue;
}

export declare function asyncable<T>(
    getter: (...values: StoresValues<Stores>[]) => AsyncValue<T> | T,
    setter: (newValue: T, oldValue: T) => AsyncValue<T> | T,
    stores: Stores
): Asyncable<T>;
